package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.KonsepDiri;
import com.jasamedika.medifirst2000.vo.KonsepDiriVO;

/**
 * Converter class between KonsepDiri and KonsepDiriVO
 * 
 * @author Askur
 */
@Component
public class KonsepDiriConverter implements BaseVoConverter<KonsepDiriVO, KonsepDiri> {
	

	public KonsepDiri transferVOToModel(KonsepDiriVO vo, KonsepDiri model) {
		if (null == model)
			model = new KonsepDiri();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, KonsepDiri.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return model;

	}

	public List<KonsepDiriVO> transferListOfModelToListOfVO(List<KonsepDiri> models,
			List<KonsepDiriVO> vos) {
		if (null == vos)
			vos = new ArrayList<KonsepDiriVO>();

		if (null == models)
			return vos;

		for (KonsepDiri KonsepDiri : models) {
			KonsepDiriVO vo = new KonsepDiriVO();
			vo = transferModelToVO(KonsepDiri, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public KonsepDiriVO transferModelToVO(KonsepDiri model, KonsepDiriVO vo) {

		if (null == vo)
			vo = new KonsepDiriVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, KonsepDiriVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	
	}

	
}
